Smart contracts

Verified contracts, their source code and ABI. Blockscout API v2 paths, served for every chain with a public Routescan API. Requests need the key of a paid plan, see Authentication.

Get verified contracts

Recently verified contracts, with optional search and language filter.

GEThttps://blockscout.routescan.io/{chainId}/api/v2/smart-contracts
GET
https://blockscout.routescan.io/1/api/v2/smart-contracts?apikey=YourApiKeyToken
1curl 'https://blockscout.routescan.io/1/api/v2/smart-contracts' \
2 -H 'x-api-key: YourApiKeyToken'
1{
2 items: {
3 address: {
4 hash: string;
5 is_contract: boolean;
6 name: string;
7 is_scam: boolean;
8 reputation: string;
9 proxy_type: string;
10 implementations: Record<string, unknown>[];
11 is_verified: boolean;
12 ens_domain_name: string;
13 metadata: string;
14 private_tags: Record<string, unknown>[];
15 watchlist_names: Record<string, unknown>[];
16 public_tags: Record<string, unknown>[];
17 };
18 certified: boolean;
19 coin_balance: string;
20 compiler_version: string;
21 has_constructor_args: boolean;
22 language: string;
23 license_type: string;
24 market_cap: string;
25 optimization_enabled: boolean;
26 reputation: string;
27 transactions_count: number;
28 verified_at: string;
29 }[];
30 next_page_params: {
31 cursor: string;
32 };
33}

Example response (Ethereum, lists cut to their first item)

jsonCopy code
1{
2 "items": [
3 {
4 "address": {
5 "hash": "0x29639869E34D34d6e6e43351D4218A592f8a66a4",
6 "is_contract": true,
7 "name": "WalletProxy",
8 "is_scam": false,
9 "reputation": "ok",
10 "proxy_type": null,
11 "implementations": [],
12 "is_verified": true,
13 "ens_domain_name": null,
14 "metadata": null,
15 "private_tags": [],
16 "watchlist_names": [],
17 "public_tags": []
18 },
19 "certified": false,
20 "coin_balance": "0",
21 "compiler_version": "v0.4.23+commit.124ca40d",
22 "has_constructor_args": false,
23 "language": "solidity",
24 "license_type": "none",
25 "market_cap": null,
26 "optimization_enabled": true,
27 "reputation": "ok",
28 "transactions_count": 0,
29 "verified_at": "2026-10-28T17:51:19.929000Z"
30 }
31 ],
32 "next_page_params": {
33 "cursor": "7b2276223a312c2273636f7065223a226d61696e6e65743a313a736d6172742d636f6e7472616374733a616c6c3a222c226b223a5b2231373933323039383333313533222c2236373233383835623737…"
34 }
35}

Get verified contracts counters

Total and new (last 24 hours) contracts and verified contracts.

GEThttps://blockscout.routescan.io/{chainId}/api/v2/smart-contracts/counters
GET
https://blockscout.routescan.io/1/api/v2/smart-contracts/counters?apikey=YourApiKeyToken
1curl 'https://blockscout.routescan.io/1/api/v2/smart-contracts/counters' \
2 -H 'x-api-key: YourApiKeyToken'
1{
2 smart_contracts: string;
3 new_smart_contracts_24h: string;
4 verified_smart_contracts: string;
5 new_verified_smart_contracts_24h: string;
6}

Example response (Ethereum, lists cut to their first item)

jsonCopy code
1{
2 "smart_contracts": "108039052",
3 "new_smart_contracts_24h": "70945",
4 "verified_smart_contracts": "5768945",
5 "new_verified_smart_contracts_24h": "82649"
6}

Get smart contract

Source code, ABI, compiler settings and proxy implementations of a contract.

GEThttps://blockscout.routescan.io/{chainId}/api/v2/smart-contracts/{address_hash}

Path parameters

address_hashstringrequired

Contract address.

GET
https://blockscout.routescan.io/1/api/v2/smart-contracts/0xdAC17F958D2ee523a2206206994597C13D831ec7?apikey=YourApiKeyToken
1curl 'https://blockscout.routescan.io/1/api/v2/smart-contracts/0xdAC17F958D2ee523a2206206994597C13D831ec7' \
2 -H 'x-api-key: YourApiKeyToken'
1{
2 conflicting_implementations: string;
3 creation_bytecode: string;
4 creation_status: string;
5 deployed_bytecode: string;
6 implementations: Record<string, unknown>[];
7 proxy_type: string;
8 abi: {
9 constant: boolean;
10 inputs: Record<string, unknown>[];
11 name: string;
12 outputs: {
13 name: string;
14 type: string;
15 }[];
16 payable: boolean;
17 stateMutability: string;
18 type: string;
19 }[];
20 additional_sources: Record<string, unknown>[];
21 can_be_visualized_via_sol2uml: boolean;
22 certified: boolean;
23 compiler_settings: {
24 optimizer: {
25 enabled: boolean;
26 runs: number;
27 };
28 outputSelection: {
29 TetherToken.sol: {
30 TetherToken: string[];
31 };
32 *: {
33 *: string[];
34 : string[];
35 };
36 };
37 };
38 compiler_version: string;
39 constructor_args: string;
40 decoded_constructor_args: string[][];
41 evm_version: string;
42 external_libraries: Record<string, unknown>[];
43 file_path: string;
44 is_blueprint: boolean;
45 is_changed_bytecode: boolean;
46 is_fully_verified: boolean;
47 is_partially_verified: boolean;
48 is_verified: boolean;
49 is_verified_via_eth_bytecode_db: boolean;
50 is_verified_via_sourcify: boolean;
51 is_verified_via_verifier_alliance: boolean;
52 language: string;
53 license_type: string;
54 name: string;
55 optimization_enabled: boolean;
56 optimization_runs: string;
57 source_code: string;
58 sourcify_repo_url: string;
59 verified_at: string;
60 verified_twin_address_hash: string;
61}

Example response (Ethereum, lists cut to their first item)

jsonCopy code
1{
2 "conflicting_implementations": null,
3 "creation_bytecode": "0x606060405260008060146101000a81548160ff0219169083151502179055506000600355600060045534156200003457600080fd5b60405162002d7c38038062002d7c833981016040528080519060…",
4 "creation_status": "success",
5 "deployed_bytecode": "0x606060405260043610610196576000357c0100000000000000000000000000000000000000000000000000000000900463ffffffff16806306fdde031461019b5780630753c30c1461022957806309…",
6 "implementations": [],
7 "proxy_type": null,
8 "abi": [
9 {
10 "constant": true,
11 "inputs": [],
12 "name": "name",
13 "outputs": [
14 {
15 "name": "",
16 "type": "string"
17 }
18 ],
19 "payable": false,
20 "stateMutability": "view",
21 "type": "function"
22 }
23 ],
24 "additional_sources": [],
25 "can_be_visualized_via_sol2uml": true,
26 "certified": false,
27 "compiler_settings": {
28 "optimizer": {
29 "enabled": false,
30 "runs": 0
31 },
32 "outputSelection": {
33 "TetherToken.sol": {
34 "TetherToken": [
35 "*"
36 ]
37 },
38 "*": {
39 "*": [
40 "abi",
41 "evm.bytecode"
42 ],
43 "": [
44 "ast"
45 ]
46 }
47 }
48 },
49 "compiler_version": "v0.4.18+commit.9cf6e910",
50 "constructor_args": "0x000000000000000000000000000000000000000000000000000000174876e8000000000000000000000000000000000000000000000000000000000000000080000000000000000000000000000000…",
51 "decoded_constructor_args": [
52 [
53 "100000000000",
54 {
55 "name": "_initialSupply",
56 "type": "uint256"
57 }
58 ]
59 ],
60 "evm_version": "default",
61 "external_libraries": [],
62 "file_path": "TetherToken.sol",
63 "is_blueprint": false,
64 "is_changed_bytecode": false,
65 "is_fully_verified": false,
66 "is_partially_verified": true,
67 "is_verified": true,
68 "is_verified_via_eth_bytecode_db": false,
69 "is_verified_via_sourcify": false,
70 "is_verified_via_verifier_alliance": false,
71 "language": "solidity",
72 "license_type": "none",
73 "name": "TetherToken",
74 "optimization_enabled": false,
75 "optimization_runs": null,
76 "source_code": "pragma solidity ^0.4.17;\r\n\r\n/**\r\n * @title SafeMath\r\n * @dev Math operations with safety checks that throw on error\r\n */\r\nlibrary SafeMath {\r\n function mul(u…",
77 "sourcify_repo_url": null,
78 "verified_at": "2024-03-07T13:44:42.408000Z",
79 "verified_twin_address_hash": null
80}
Questions? Contact us